diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
index 76914f1ad..2dfba223b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -16,11 +16,11 @@ public class BlockLogicPlanksPainted extends BlockLogic implements IPainted
 {
     public BlockLogicPlanksPainted(@NotNull Block<?> block)
     {
-        super(block, Material.wood);
+        super(block, Materials.WOOD);
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         return itemStack.getMetadata();
     }
 
@@ -46,12 +46,12 @@ public class BlockLogicPlanksPainted extends BlockLogic implements IPainted
     }
 
     @Override
-    public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+    public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         world.setBlockIdNotify(tilePos, Blocks.PLANKS_OAK.id());
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         IPainted.super.setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index 741dd7bac..7e529741b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
@@ -11,20 +11,22 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
-{
+public class BlockLogicPortal extends BlockLogicTransparent implements IPainted {
     public static final int MAX_PORTAL_SIZE = 32;
     public static final int MASK_COLOR = 0b1111_0000;
     public static final int MASK_ROTATION = 0b0000_0011;
@@ -33,57 +35,51 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     public static final int ORIENTATION_X = 0;
     public static final int ORIENTATION_Z = 1;
     public static final int ORIENTATION_Y = 2;
-	public final @NotNull Dimension targetDimension;
-	public final @NotNull Block<?> portalFrame;
-	public final @NotNull Block<?> portalTrigger;
-		
-    public BlockLogicPortal(@NotNull Block<?> block, @NotNull Dimension targetDimension, @NotNull Block<?> portalMaterial, @NotNull Block<?> portalTrigger)
-    {
-        super(block, Material.portal);
+    public final @NotNull Dimension targetDimension;
+    public final @NotNull Block<?> portalFrame;
+    public final @NotNull Block<?> portalTrigger;
+
+    public BlockLogicPortal(@NotNull Block<?> block, @NotNull Dimension targetDimension, @NotNull Block<?> portalMaterial, @NotNull Block<?> portalTrigger) {
+        super(block, Materials.PORTAL);
         this.targetDimension = targetDimension;
         this.portalFrame = portalMaterial;
         this.portalTrigger = portalTrigger;
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int meta = source.getBlockData(tilePos);
-        if((meta & 0x1) > 0)
-        {
+        if ((meta & 0x1) > 0) {
             float f1 = 0.125F;
             float f3 = 0.5F;
-            return AABB.fromPool(0.5F - f1, 0.0F, 0.5F - f3, 0.5F + f1, 1.0F, 0.5F + f3);
-        } else
-        {
+            return new AABBd(0.5F - f1, 0.0F, 0.5F - f3, 0.5F + f1, 1.0F, 0.5F + f3);
+        } else {
             float f = 0.5F;
             float f2 = 0.125F;
-            return AABB.fromPool(0.5F - f, 0.0F, 0.5F - f2, 0.5F + f, 1.0F, 0.5F + f2);
+            return new AABBd(0.5F - f, 0.0F, 0.5F - f2, 0.5F + f, 1.0F, 0.5F + f2);
         }
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
-    public @Nullable Bounds getPortalDims(@NotNull World world, @NotNull TilePos tilePos, boolean expectMiddle)
-    {
-    	return getPortalDims(world, tilePos, false, expectMiddle);
+    public @Nullable Bounds getPortalDims(@NotNull World world, @NotNull TilePosc tilePos, boolean expectMiddle) {
+        return getPortalDims(world, tilePos, false, expectMiddle);
     }
-    
-    public @Nullable Bounds getPortalDims(@NotNull World world, @NotNull TilePos tilePos, boolean swapOrientation, boolean expectMiddle)
-    {
+
+    public @Nullable Bounds getPortalDims(@NotNull World world, @NotNull TilePosc tilePos, boolean swapOrientation, boolean expectMiddle) {
         final int maxDims = MAX_PORTAL_SIZE;
 
 
@@ -96,14 +92,13 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         boolean foundBottom = false;
 
         Axis axis = Axis.NONE;
-        
+
         // Check if valid dimension
         if (world.dimension.portalBlock != null && world.dimension.portalBlock != this.block) return null;
 
         // Sink to minimum Y
         for (int ry = 0; ry > -maxDims; ry--) {
-            if (world.getBlockId(tempPos.set(p.x, p.y + ry, p.z)) == this.portalFrame.id())
-            {
+            if (world.getBlockId(tempPos.set(p.x, p.y + ry, p.z)) == this.portalFrame.id()) {
                 foundBottom = true;
                 p.y += ry;
                 break;
@@ -115,44 +110,43 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         p.y++;
 
         if (!swapOrientation) {
-        	// Find orientation and minimum bound
-        	for (int rx = 0; rx > -maxDims; rx--) {
-        		if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
+            // Find orientation and minimum bound
+            for (int rx = 0; rx > -maxDims; rx--) {
+                if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
                     axis = Axis.X;
                     p.x += rx;
-        			break;
-        		}
-        	}
-        	
-        	if (axis == Axis.NONE) {
-        		for (int rz = 0; rz > -maxDims; rz--) {
-        			if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
-        				axis = Axis.Z;
+                    break;
+                }
+            }
+
+            if (axis == Axis.NONE) {
+                for (int rz = 0; rz > -maxDims; rz--) {
+                    if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
+                        axis = Axis.Z;
                         p.z += rz;
-        				break;
-        			}
-        		}
-        	}
-        }
-        else {
-        	// Find orientation and minimum bound
-        	for (int rz = 0; rz > -maxDims; rz--) {
-        		if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
+                        break;
+                    }
+                }
+            }
+        } else {
+            // Find orientation and minimum bound
+            for (int rz = 0; rz > -maxDims; rz--) {
+                if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
                     axis = Axis.Z;
                     p.z += rz;
-        			break;
-        		}
-        	}
-        	
-        	if (axis == Axis.NONE) {
-        		for (int rx = 0; rx > -maxDims; rx--) {
-        			if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
-        				axis = Axis.X;
+                    break;
+                }
+            }
+
+            if (axis == Axis.NONE) {
+                for (int rx = 0; rx > -maxDims; rx--) {
+                    if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
+                        axis = Axis.X;
                         p.x += rx;
-        				break;
-        			}
-        		}
-        	}
+                        break;
+                    }
+                }
+            }
         }
 
         if (axis == Axis.NONE) return null;
@@ -161,10 +155,8 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         switch (axis) {
             case X: {
                 // Find in X direction
-                for (int rx = 1; rx < maxDims; rx++)
-                {
-                    if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id())
-                    {
+                for (int rx = 1; rx < maxDims; rx++) {
+                    if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
                         maxBoundA = rx;
                         break;
                     }
@@ -174,10 +166,8 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             case Z:
             default: {
                 // Find in Z direction
-                for (int rz = 1; rz < maxDims; rz++)
-                {
-                    if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id())
-                    {
+                for (int rz = 1; rz < maxDims; rz++) {
+                    if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
                         maxBoundA = rz;
                         break;
                     }
@@ -192,12 +182,11 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         p.y--;
 
         // Find maximum bound in Y direction
-        for (int ry = 1; ry < maxDims; ry++)
-        {
-            if (p.y + ry >= world.getHeightBlocks()) return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
+        for (int ry = 1; ry < maxDims; ry++) {
+            if (p.y + ry >= world.getHeightBlocks())
+                return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
 
-            if (world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? 1 : 0), p.y + ry, p.z + (axis == Axis.Z ? 1 : 0))) == this.portalFrame.id())
-            {
+            if (world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? 1 : 0), p.y + ry, p.z + (axis == Axis.Z ? 1 : 0))) == this.portalFrame.id()) {
                 maxBoundY = ry;
                 break;
             }
@@ -207,52 +196,41 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         if (maxBoundY == 0) return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
 
         // Check portal structure
-        for (int ra = 0; ra <= maxBoundA; ra++)
-        {
-            for (int ry = 0; ry <= maxBoundY; ry++)
-            {
+        for (int ra = 0; ra <= maxBoundA; ra++) {
+            for (int ry = 0; ry <= maxBoundY; ry++) {
                 // Check edges are correct
-                if (ra == 0 || ra == maxBoundA || ry == 0 || ry == maxBoundY)
-                {
-                    if (world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0))) != this.portalFrame.id())
-                    {
-                    	return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
+                if (ra == 0 || ra == maxBoundA || ry == 0 || ry == maxBoundY) {
+                    if (world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0))) != this.portalFrame.id()) {
+                        return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
                     }
-                }
-                else // Check interior is empty/fire
+                } else // Check interior is empty/fire
                 {
                     int id = world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0)));
 
-                    if (id != 0 && id != this.portalTrigger.id() && id != this.block.id())
-                    {
-                    	return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
+                    if (id != 0 && id != this.portalTrigger.id() && id != this.block.id()) {
+                        return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
                     }
                 }
             }
         }
 
         // Check middle (if applicable)
-        if (expectMiddle)
-        {
-            for (int ra = 1; ra < maxBoundA; ra++)
-            {
-                for (int ry = 1; ry < maxBoundY; ry++)
-                {
+        if (expectMiddle) {
+            for (int ra = 1; ra < maxBoundA; ra++) {
+                for (int ry = 1; ry < maxBoundY; ry++) {
                     int id = world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0)));
 
-                    if (id != this.block.id())
-                    {
-                    	return swapOrientation ? null : getPortalDims(world, tilePos, true, true);
+                    if (id != this.block.id()) {
+                        return swapOrientation ? null : getPortalDims(world, tilePos, true, true);
                     }
                 }
             }
         }
 
-        return new Bounds(axis, tilePos, maxBoundA, maxBoundY);
+        return new Bounds(axis, new TilePos(tilePos), maxBoundA, maxBoundY);
     }
 
-    public boolean tryToCreatePortal(@NotNull World world, @NotNull TilePos tilePos, @Nullable DyeColor color)
-    {
+    public boolean tryToCreatePortal(@NotNull World world, @NotNull TilePosc tilePos, @Nullable DyeColor color) {
         if (color == null) {
             color = DyeColor.PURPLE;
         }
@@ -263,8 +241,8 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         switch (bounds.axis) {
             case X: {
                 TilePos p = new TilePos(0, 0, 0);
-                for(int ra = 1; ra < bounds.maxBoundA; ra++) {
-                    for(int ry = 1; ry < bounds.maxBoundB; ry++) {
+                for (int ra = 1; ra < bounds.maxBoundA; ra++) {
+                    for (int ry = 1; ry < bounds.maxBoundB; ry++) {
                         p.x = bounds.pos.x + ra;
                         p.y = bounds.pos.y + ry;
                         p.z = bounds.pos.z;
@@ -278,13 +256,13 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                 world.setBlockData(p, (ORIENTATION_X & 0xF) | 0x2);
                 setColor(world, p, color);
 
-                world.markBlocksDirty(p, p.add(bounds.maxBoundA, bounds.maxBoundB, 0));
+                world.markBlocksDirty(p, p.add(bounds.maxBoundA, bounds.maxBoundB, 0, new TilePos()));
                 break;
             }
             case Z: {
                 TilePos p = new TilePos(0, 0, 0);
-                for(int ra = 1; ra < bounds.maxBoundA; ra++) {
-                    for(int ry = 1; ry < bounds.maxBoundB; ry++) {
+                for (int ra = 1; ra < bounds.maxBoundA; ra++) {
+                    for (int ry = 1; ry < bounds.maxBoundB; ry++) {
                         p.x = bounds.pos.x;
                         p.y = bounds.pos.y + ry;
                         p.z = bounds.pos.z + ra;
@@ -299,7 +277,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                 world.setBlockData(p, (ORIENTATION_Z & 0xF) | 0x2);
                 setColor(world, p, color);
 
-                world.markBlocksDirty(p, p.add(0, bounds.maxBoundB, bounds.maxBoundA));
+                world.markBlocksDirty(p, p.add(0, bounds.maxBoundB, bounds.maxBoundA, new TilePos()));
                 break;
             }
         }
@@ -309,7 +287,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
         Bounds bounds = getPortalDims(world, tilePos, true);
 
         if (bounds == null) {
@@ -323,7 +301,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     }
 
     @Override
-    public void onEntityCollision(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity) {
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
         if (entity instanceof EntityItem entityItem && entityItem.item != null && entityItem.item.itemID == Items.DYE.id) {
             DyeColor color = DyeColor.colorFromItemMeta(entityItem.item.getMetadata());
             if (getColor(world, tilePos) != color) {
@@ -335,39 +313,33 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                 }
             }
         }
-        if(entity.vehicle == null && entity.passenger == null) {
+        if (entity.vehicle == null && entity.passenger == null) {
             entity.handlePortal(this.block.id(), getColor(world, tilePos));
         }
     }
 
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand)
-    {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         int meta = world.getBlockData(tilePos);
-        if((meta & 0x2) > 0 && rand.nextInt(20) == 0)
-        {
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D, "portal.portal", 0.5F, rand.nextFloat() * 0.4F + 0.8F);
+        if ((meta & 0x2) > 0 && rand.nextInt(20) == 0) {
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.5D, (double) tilePos.z() + 0.5D, "portal.portal", 0.5F, rand.nextFloat() * 0.4F + 0.8F);
         }
 
-        TilePos west = tilePos.west();
-        TilePos east = tilePos.east();
-        for(int l = 0; l < 4; l++)
-        {
-            double px = (double) tilePos.x + rand.nextFloat();
-            double py = (double) tilePos.y + rand.nextFloat();
-            double pz = (double) tilePos.z + rand.nextFloat();
+        TilePos queryPos = new TilePos();
+        for (int l = 0; l < 4; l++) {
+            double px = (double) tilePos.x() + rand.nextFloat();
+            double py = (double) tilePos.y() + rand.nextFloat();
+            double pz = (double) tilePos.z() + rand.nextFloat();
             int i1 = rand.nextInt(2) * 2 - 1;
             double xd = (rand.nextDouble() - 0.5D) * 0.5D;
             double yd = (rand.nextDouble() - 0.5D) * 0.5D;
             double zd = (rand.nextDouble() - 0.5D) * 0.5D;
-            if(world.getBlockId(west) == this.block.id() || world.getBlockId(east) == this.block.id())
-            {
-                pz = (double) tilePos.z + 0.5D + 0.25D * (double)i1;
-                zd = rand.nextFloat() * 2.0D * (double)i1;
-            } else
-            {
-                px = (double) tilePos.x + 0.5D + 0.25D * (double)i1;
-                xd = rand.nextFloat() * 2.0D * (double)i1;
+            if (world.getBlockId(tilePos.add(Direction.WEST, queryPos)) == this.block.id() || world.getBlockId(tilePos.add(Direction.EAST, queryPos)) == this.block.id()) {
+                pz = (double) tilePos.z() + 0.5D + 0.25D * (double) i1;
+                zd = rand.nextFloat() * 2.0D * (double) i1;
+            } else {
+                px = (double) tilePos.x() + 0.5D + 0.25D * (double) i1;
+                xd = rand.nextFloat() * 2.0D * (double) i1;
             }
             world.spawnParticle("portal", px, py, pz, xd, yd, zd, fromMetadata(meta).blockMeta);
         }
@@ -391,19 +363,19 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     }
 
     @Override
-    public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+    public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataNotify(tilePos, Blocks.STAIRS_PLANKS_OAK.id(), stripColorFromMetadata(meta));
     }
 
     @Override
-    public @NotNull DyeColor getColor(@NotNull World world, @NotNull TilePos tilePos) {
+    public @NotNull DyeColor getColor(@NotNull World world, @NotNull TilePosc tilePos) {
         return IPainted.super.getColor(world, tilePos);
     }
 
     // TODO implement block updates without causing lag spikes
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         Bounds bounds = getPortalDims(world, tilePos, true);
         if (bounds == null) {
             world.setBlockIdNotify(tilePos, 0);
@@ -415,8 +387,8 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         TilePos p = new TilePos(tilePos);
         switch (bounds.axis) {
             case X: {
-                for(int ra = 1; ra < bounds.maxBoundA; ra++) {
-                    for(int ry = 1; ry < bounds.maxBoundB; ry++) {
+                for (int ra = 1; ra < bounds.maxBoundA; ra++) {
+                    for (int ry = 1; ry < bounds.maxBoundB; ry++) {
                         p.x = portalPos.x + ra;
                         p.y = portalPos.y + ry;
                         p.z = portalPos.z;
@@ -426,8 +398,8 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                 break;
             }
             case Z: {
-                for(int ra = 1; ra < bounds.maxBoundA; ra++) {
-                    for(int ry = 1; ry < bounds.maxBoundB; ry++) {
+                for (int ra = 1; ra < bounds.maxBoundA; ra++) {
+                    for (int ry = 1; ry < bounds.maxBoundB; ry++) {
                         p.x = portalPos.x;
                         p.y = portalPos.y + ry;
                         p.z = portalPos.z + ra;
@@ -439,7 +411,6 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         }
 
 
-
 //        if (bounds[0] == ORIENTATION_X) {
 //            world.markBlocksDirty(px + 1, py + 1, pz, px + bounds[4], py + bounds[5], pz);
 //        } else {
@@ -453,5 +424,6 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         world.setBlockDataNotify(tilePos, stripColorFromMetadata(meta) | toMetadata(color) | MASK_COLOR_SET);
     }
 
-    public record Bounds(@NotNull Axis axis, @NotNull TilePos pos, int maxBoundA, int maxBoundB) { }
+    public record Bounds(@NotNull Axis axis, @NotNull TilePos pos, int maxBoundA, int maxBoundB) {
+    }
 }
